(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["CKEditor5"] = factory();
	else
		root["CKEditor5"] = root["CKEditor5"] || {}, root["CKEditor5"]["IconifyFieldPlugin"] = factory();
})(self, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "ckeditor5/src/core.js":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = (__webpack_require__("dll-reference CKEditor5.dll"))("./src/core.js");

/***/ }),

/***/ "ckeditor5/src/ui.js":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = (__webpack_require__("dll-reference CKEditor5.dll"))("./src/ui.js");

/***/ }),

/***/ "ckeditor5/src/widget.js":
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = (__webpack_require__("dll-reference CKEditor5.dll"))("./src/widget.js");

/***/ }),

/***/ "dll-reference CKEditor5.dll":
/***/ ((module) => {

"use strict";
module.exports = CKEditor5.dll;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ src)
});

// EXTERNAL MODULE: delegated ./core.js from dll-reference CKEditor5.dll
var delegated_corefrom_dll_reference_CKEditor5 = __webpack_require__("ckeditor5/src/core.js");
// EXTERNAL MODULE: delegated ./widget.js from dll-reference CKEditor5.dll
var delegated_widgetfrom_dll_reference_CKEditor5 = __webpack_require__("ckeditor5/src/widget.js");
;// CONCATENATED MODULE: ./js/ckeditor5_plugins/IconifyFieldPlugin/src/insert_iconify_field_command.ts

class InsertIconifyFieldCommand extends delegated_corefrom_dll_reference_CKEditor5.Command {
    execute(options) {
        var _a, _b;
        const { model } = this.editor;
        if (options === null || options === void 0 ? void 0 : options.icon) {
            model.change((writer) => {
                model.insertObject(this._createIconifyField(writer, options.icon, options.attributes), null, null, {
                    setSelection: 'on',
                });
            });
            return;
        }
        const config = this.editor.config.get('iconifyField');
        const query = new URLSearchParams({
            default_collection: (_a = config.defaultCollection) !== null && _a !== void 0 ? _a : '',
            collections: (_b = config.collections) !== null && _b !== void 0 ? _b : '',
        });
        const modal = Drupal.ajax({
            url: `/admin/iconify_field/menu-icons/picker?${query}`,
            dialogType: 'modal',
            dialog: {
                height: 600,
                width: 800,
            },
        });
        modal.execute();
        document.body.addEventListener('iconify-field-pick-icon', (event) => {
            const closeBtn = document.body.querySelector('.ui-dialog-titlebar-close');
            if (closeBtn)
                closeBtn.click();
            const icon = event.detail.text;
            model.change((writer) => {
                model.insertObject(this._createIconifyField(writer, icon, {
                    'class': 'iconify-field',
                    'aria-hidden': 'true',
                }), null, null, {
                    setSelection: 'on',
                });
            });
        });
    }
    refresh() {
        const { model } = this.editor;
        const { selection } = model.document;
        const position = selection.getFirstPosition();
        if (!position)
            return;
        const allowedIn = model.schema.findAllowedParent(position, 'iconifyField');
        this.isEnabled = allowedIn !== null;
    }
    _createIconifyField(writer, icon, attributes) {
        const iconifyField = writer.createElement('iconifyField', {
            'data-icon': icon,
            ...attributes,
        });
        return iconifyField;
    }
}

;// CONCATENATED MODULE: ./js/ckeditor5_plugins/IconifyFieldPlugin/src/iconify_field_editing.ts



class IconifyFieldEditing extends delegated_corefrom_dll_reference_CKEditor5.Plugin {
    static get requires() {
        return [delegated_widgetfrom_dll_reference_CKEditor5.Widget];
    }
    init() {
        this._defineSchema();
        this._defineConverters();
        this.editor.commands.add('insertIconifyField', new InsertIconifyFieldCommand(this.editor));
    }
    _defineSchema() {
        const { schema } = this.editor.model;
        schema.register('iconifyField', {
            inheritAllFrom: '$inlineObject',
            allowAttributes: [
                'class',
                'data-icon',
                'aria-hidden',
                'aria-label',
                'role',
            ],
        });
    }
    _defineConverters() {
        const { conversion } = this.editor;
        conversion.for('upcast').elementToElement({
            model: (viewElement, { writer }) => {
                const attributes = this._parseAttributes(viewElement.getAttributes());
                return writer.createElement('iconifyField', {
                    'data-icon': viewElement.getAttribute('data-icon'),
                    ...attributes,
                });
            },
            view: {
                name: 'span',
                classes: 'iconify-field',
            },
        });
        conversion.for('dataDowncast').elementToElement({
            model: 'iconifyField',
            view: (modelElement, { writer }) => {
                return this._createIconifyFieldView(modelElement, writer);
            },
        });
        conversion.for('editingDowncast').elementToElement({
            model: 'iconifyField',
            view: (modelElement, { writer }) => {
                const element = this._createIconifyFieldView(modelElement, writer);
                return (0,delegated_widgetfrom_dll_reference_CKEditor5.toWidget)(element, writer);
            },
        });
    }
    _createIconifyFieldView(modelElement, writer) {
        var _a;
        const icon = (_a = modelElement.getAttribute('data-icon')) !== null && _a !== void 0 ? _a : '';
        const attributes = this._parseAttributes(modelElement.getAttributes());
        const element = writer.createContainerElement('span', {
            'class': 'iconify-field',
            'data-icon': icon,
            ...attributes,
        });
        element._appendChild(writer.createRawElement('span', {
            class: 'iconify-field--icon',
            style: icon
                ? `mask-image: url(/api/iconify_field_ckeditor/icon/${icon})`
                : undefined,
        }));
        return element;
    }
    _parseAttributes(elAttributes) {
        const attributes = {};
        for (const [key, value] of elAttributes)
            attributes[key] = value;
        return attributes;
    }
}

// EXTERNAL MODULE: delegated ./ui.js from dll-reference CKEditor5.dll
var delegated_uifrom_dll_reference_CKEditor5 = __webpack_require__("ckeditor5/src/ui.js");
;// CONCATENATED MODULE: ./js/ckeditor5_plugins/IconifyFieldPlugin/img/IconifyField.svg
/* harmony default export */ const IconifyField = ("<svg xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" width=\"1em\" height=\"1em\" viewBox=\"0 0 24 24\"><path fill=\"currentColor\" d=\"M20 12a8 8 0 0 0-8-8a8 8 0 0 0-8 8a8 8 0 0 0 8 8a8 8 0 0 0 8-8m2 0a10 10 0 0 1-10 10A10 10 0 0 1 2 12A10 10 0 0 1 12 2a10 10 0 0 1 10 10M10 9.5c0 .8-.7 1.5-1.5 1.5S7 10.3 7 9.5S7.7 8 8.5 8s1.5.7 1.5 1.5m7 0c0 .8-.7 1.5-1.5 1.5S14 10.3 14 9.5S14.7 8 15.5 8s1.5.7 1.5 1.5m-5 7.73c-1.75 0-3.29-.73-4.19-1.81L9.23 14c.45.72 1.52 1.23 2.77 1.23s2.32-.51 2.77-1.23l1.42 1.42c-.9 1.08-2.44 1.81-4.19 1.81\"></path></svg>\n");
;// CONCATENATED MODULE: ./js/ckeditor5_plugins/IconifyFieldPlugin/src/iconify_field_options_form_view.ts


class IconifyFieldOptionsFormView extends delegated_uifrom_dll_reference_CKEditor5.View {
    constructor(locale) {
        super(locale);
        this._classInput = this._createClassInputView();
        this._decorativeToggle = this._decorativeToggleView();
        this._ariaNameInput = this._createAriaNameInputView();
        this._saveButtonView = this._createButton(Drupal.t('Save'), delegated_corefrom_dll_reference_CKEditor5.icons.check, 'ck-button-save');
        this._saveButtonView.type = 'submit';
        this._saveButtonView.bind('isEnabled').to(this._decorativeToggle, 'isOn', this._ariaNameInput, 'isEmpty', (isDecorativeToggleOn, isLabeledInputEmpty) => isDecorativeToggleOn || !isLabeledInputEmpty);
        this._cancelButtonView = this._createButton(Drupal.t('Cancel'), delegated_corefrom_dll_reference_CKEditor5.icons.cancel, 'ck-button-cancel', 'cancel');
        this.setTemplate({
            tag: 'form',
            attributes: {
                class: [
                    'ck',
                    'ck-link-form',
                    'ck-vertical-form',
                    'ck-link-form_layout-vertical',
                ],
                tabindex: '-1',
            },
            children: [
                this._classInput,
                {
                    tag: 'div',
                    attributes: {
                        class: [
                            'ck',
                        ],
                    },
                    children: [
                        this._decorativeToggle,
                    ],
                },
                this._ariaNameInput,
                this._saveButtonView,
                this._cancelButtonView,
            ],
        });
    }
    render() {
        super.render();
        (0,delegated_uifrom_dll_reference_CKEditor5.submitHandler)({ view: this });
    }
    reset(element) {
        var _a, _b;
        const elAttributes = element.getAttributes();
        const attributes = {};
        for (const [key, value] of elAttributes)
            attributes[key] = value;
        const classes = attributes.class.replace('iconify-field', '').trim();
        this._setInputValue(this._classInput.fieldView, classes);
        this._decorativeToggle.isOn = !!((_a = attributes['aria-hidden']) !== null && _a !== void 0 ? _a : false);
        this._setInputValue(this._ariaNameInput.fieldView, (_b = attributes['aria-label']) !== null && _b !== void 0 ? _b : '');
    }
    _setInputValue(input, value) {
        ;
        input.value = value;
        if (input.element)
            input.element.value = value;
    }
    getClassInputValue() {
        var _a;
        const classes = (_a = this._classInput.fieldView.element) === null || _a === void 0 ? void 0 : _a.value;
        return `iconify-field ${classes}`;
    }
    isDecorativeToggleOn() {
        return this._decorativeToggle.isOn;
    }
    getAriaNameInputValue() {
        var _a;
        return (_a = this._ariaNameInput.fieldView.element) === null || _a === void 0 ? void 0 : _a.value;
    }
    _decorativeToggleView() {
        const decorativeToggle = new delegated_uifrom_dll_reference_CKEditor5.SwitchButtonView(this.locale);
        decorativeToggle.set({
            withText: true,
            label: Drupal.t('Decorative image'),
            class: [
                'ck-labeled-field-view',
            ],
        });
        decorativeToggle.on('execute', () => {
            decorativeToggle.set('isOn', !decorativeToggle.isOn);
        });
        return decorativeToggle;
    }
    _createClassInputView() {
        const classInput = new delegated_uifrom_dll_reference_CKEditor5.LabeledFieldView(this.locale, delegated_uifrom_dll_reference_CKEditor5.createLabeledInputText);
        classInput.label = Drupal.t('Additional classes');
        return classInput;
    }
    _createAriaNameInputView() {
        const ariaNameInput = new delegated_uifrom_dll_reference_CKEditor5.LabeledFieldView(this.locale, delegated_uifrom_dll_reference_CKEditor5.createLabeledInputText);
        ariaNameInput
            .bind('class')
            .to(this._decorativeToggle, 'isOn', value => (value ? 'ck-hidden' : ''));
        ariaNameInput.label = Drupal.t('Accessible name');
        return ariaNameInput;
    }
    _createButton(label, icon, className, eventName) {
        const button = new delegated_uifrom_dll_reference_CKEditor5.ButtonView(this.locale);
        button.set({
            label,
            icon,
            tooltip: true,
        });
        button.extendTemplate({
            attributes: {
                class: className,
            },
        });
        if (eventName)
            button.delegate('execute').to(this, eventName);
        return button;
    }
}

;// CONCATENATED MODULE: ./js/ckeditor5_plugins/IconifyFieldPlugin/src/iconify_field_ui.ts




class IconifyFieldUI extends delegated_corefrom_dll_reference_CKEditor5.Plugin {
    static get requires() {
        return [delegated_uifrom_dll_reference_CKEditor5.ContextualBalloon];
    }
    init() {
        const { editor } = this;
        this._createFormBalloon();
        editor.ui.componentFactory.add('iconifyField', (locale) => {
            const buttonView = new delegated_uifrom_dll_reference_CKEditor5.ButtonView(locale);
            buttonView.set({
                label: editor.t('Icon'),
                icon: IconifyField,
                tooltip: true,
            });
            this.listenTo(buttonView, 'execute', () => editor.execute('insertIconifyField'));
            return buttonView;
        });
        this.listenTo(this._form, 'submit', () => {
            var _a;
            const { editor } = this;
            const { selection } = editor.model.document;
            const element = selection.getSelectedElement();
            if (!element)
                return;
            const insertParams = {
                icon: (_a = element.getAttribute('data-icon')) !== null && _a !== void 0 ? _a : '',
                attributes: {},
            };
            if (!insertParams)
                return;
            insertParams.attributes.class = this._form.getClassInputValue();
            if (this._form.isDecorativeToggleOn()) {
                insertParams.attributes['aria-hidden'] = 'true';
            }
            else {
                insertParams.attributes['aria-label'] = this._form.getAriaNameInputValue();
                insertParams.attributes.role = 'img';
            }
            editor.execute('insertIconifyField', insertParams);
        });
        this.listenTo(this._form, 'cancel', () => {
            this._hideUI();
        });
        editor.model.document.on('change:data', () => {
            this._hideUI();
        });
    }
    _createFormBalloon() {
        const { editor } = this;
        const viewDocument = editor.editing.view.document;
        this._balloon = this.editor.plugins.get(delegated_uifrom_dll_reference_CKEditor5.ContextualBalloon);
        this._form = new IconifyFieldOptionsFormView(this.editor.locale);
        this.listenTo(viewDocument, 'click', () => {
            const iconifyField = this._getSelectedIconifyFieldElement();
            if (iconifyField)
                this._showUI();
        });
        (0,delegated_uifrom_dll_reference_CKEditor5.clickOutsideHandler)({
            emitter: this._form,
            activator: () => this._balloon.hasView(this._form),
            contextElements: [this._balloon.view.element],
            callback: () => this._hideUI(),
        });
    }
    _showUI() {
        const { editor } = this;
        const { view } = editor.editing;
        const { selection } = editor.model.document;
        const element = selection.getSelectedElement();
        if (element)
            this._form.reset(element);
        const range = view.document.selection.getFirstRange();
        if (!range)
            return;
        const position = view.domConverter.viewRangeToDom(range);
        this._balloon.add({
            view: this._form,
            position: {
                target: position,
            },
        });
    }
    _hideUI() {
        this.editor.editing.view.focus();
        if (this._balloon.hasView(this._form))
            this._balloon.remove(this._form);
    }
    _getSelectedIconifyFieldElement() {
        const { selection } = this.editor.editing.view.document;
        const selectedElement = selection.getSelectedElement();
        if (!(selectedElement === null || selectedElement === void 0 ? void 0 : selectedElement.hasClass('iconify-field')) || !selectedElement.hasAttribute('data-icon'))
            return null;
        return selectedElement !== null && selectedElement !== void 0 ? selectedElement : null;
    }
}

;// CONCATENATED MODULE: ./js/ckeditor5_plugins/IconifyFieldPlugin/src/iconify_field.ts



class iconify_field_IconifyField extends delegated_corefrom_dll_reference_CKEditor5.Plugin {
    static get requires() {
        return [
            IconifyFieldEditing,
            IconifyFieldUI,
        ];
    }
}

;// CONCATENATED MODULE: ./js/ckeditor5_plugins/IconifyFieldPlugin/src/index.ts

/* harmony default export */ const src = ({
    IconifyField: iconify_field_IconifyField,
});

})();

__webpack_exports__ = __webpack_exports__["default"];
/******/ 	return __webpack_exports__;
/******/ })()
;
});